// Generated by PEG.js v0.11.0-master.f69239d, https://pegjs.org/
// With pegjs-ts-plugin, https://gitlab.com/kihub.io/pegjs-ts-plugin



// Initializer code START

  const crypto = require('crypto')
  import {
    PartLibrary,
    PartLibraryVersion,
    PartDef,
    Part,
    FieldOrientation,
    Field,
    DrawSection,
    DrawList,
    DrawPrimitiveType,
    FillType,
    HorizontalAlignment,
    VerticalAlignment,
    DrawOrientationType,
    PinShapeType,
    DrawPrimitive,
    DrawArc,
    DrawCircle,
    DrawPolyline,
    DrawRect,
    DrawText,
    PinType,
    DrawPin,
    Convert,
    Position
  } from '../types';

  interface FieldDetails {
    name?: string;
    value: string;
    position: Position;
    size: number;
    orientation: FieldOrientation;
    visible: boolean;
    halign: HorizontalAlignment;
    valign: VerticalAlignment;
    italic: boolean;
    bold: boolean;
  }


// Initializer code END

type T_PartLibrary = PartLibrary;  // PartLibrary
type T_LibraryHeader = PartLibraryVersion;  // LibraryHeader
type T_Part = Part;  // Part
type T_DEFLine = PartDef;  // DEFLine
type T_ENDDEFLine = [string,T_NEWLINE];  // ENDDEFLine
type T_FieldDetails = FieldDetails;  // FieldDetails
type T_Field = Field;  // Field
type T_FPLIST = string[];  // FPLIST
type T_FPLISTStart = [string,T_NEWLINE];  // FPLISTStart
type T_FPLISTEnd = [string,T_NEWLINE];  // FPLISTEnd
type T_FPPattern = string;  // FPPattern
type T_Aliases = string[];  // Aliases
type T_DRAWSection = DrawSection;  // DRAWSection
type T_DRAWStart = [string,T_NEWLINE];  // DRAWStart
type T_DRAWEnd = [string,T_NEWLINE];  // DRAWEnd
type T_DrawPrimitive = (T_DrawArc|T_DrawCircle|T_DrawPolyline|T_DrawRect|T_DrawText|T_DrawPin);  // DrawPrimitive
type T_DrawArc = DrawArc;  // DrawArc
type T_DrawCircle = DrawCircle;  // DrawCircle
type T_DrawPolyline = DrawPolyline;  // DrawPolyline
type T_DrawRect = DrawRect;  // DrawRect
type T_DrawText = DrawText;  // DrawText
type T_DrawPin = DrawPin;  // DrawPin
type T_Name = string;  // Name
type T_Integer = number;  // Integer
type T_Positive = number;  // Positive
type T_YN = boolean;  // YN
type T_FL = boolean;  // FL
type T_PN = boolean;  // PN
type T_HV = FieldOrientation;  // HV
type T_VI = boolean;  // VI
type T_ZeroOne = boolean;  // ZeroOne
type T_CLR = HorizontalAlignment;  // CLR
type T_CTB = VerticalAlignment;  // CTB
type T_Italic = boolean;  // Italic
type T_IN = boolean;  // IN
type T_BN = boolean;  // BN
type T_FILL = FillType;  // FILL
type T_Orientation = DrawOrientationType;  // Orientation
type T_PinType = PinType;  // PinType
type T_PinShape = [PinShapeType,boolean];  // PinShape
type T_Convert = Convert;  // Convert
type T_QuotedString = string;  // QuotedString
type T_UnquotedString = string;  // UnquotedString
type T_AlphaNumericString = string;  // AlphaNumericString
type T_EscapedString = string;  // EscapedString
type T_QuotedOrEscapedString = (T_QuotedString|T_EscapedString);  // QuotedOrEscapedString
type T_PinName = string;  // PinName
type T_PinNumber = string|null;  // PinNumber
type T__ = string[];  // _
type T_NEWLINE = string[];  // NEWLINE


export interface ParserOptions {
  startRule?: string;
  tracer?: boolean;
  filename?: string;
  [ key: string ]: any;
}

export interface FilePosition {
  offset: number;
  line: number;
  column: number;
}

export interface Location {
  filename?: string;
  start: FilePosition;
  end: FilePosition
}

export interface LiteralExpectation {
  type: "literal";
  text: string;
  ignoreCase: boolean;
}

export interface ClassParts extends Array<string | ClassParts> {}

export interface ClassExpectation {
  type: "class";
  parts: ClassParts;
  inverted: boolean;
  ignoreCase: boolean;
}

export interface AnyExpectation {
  type: "any";
}

export interface EndExpectation {
  type: "end";
}

export interface OtherExpectation {
  type: "other";
  description: string;
}

export type Expectation = LiteralExpectation | ClassExpectation | AnyExpectation | EndExpectation | OtherExpectation;

export class SyntaxError extends Error {

  expected: Expectation[]|null;
  found: string|null;
  location: Location;

  constructor(message: string, expected: Expectation[]|null, found: string|null, location: Location) {
    super(message);
    this.expected = expected;
    this.found = found;
    this.location = location;
  }

  static buildSimpleError(message: string, location: Location): SyntaxError {
    return new SyntaxError(message, null, null, location);
  }

  static buildStructuredError(expected: Expectation[], found: string, location: Location): SyntaxError {
    return new SyntaxError(
      SyntaxError.buildMessage(expected, found),
      expected,
      found,
      location
    );
  }

  private static buildMessage(expected, found) {
    var DESCRIBE_EXPECTATION_FNS = {
      literal: function(expectation) {
        return "\"" + literalEscape(expectation.text) + "\"";
      },

      class: function(expectation) {
        var escapedParts = expectation.parts.map(function(part) {
          return Array.isArray(part)
            ? classEscape(part[0]) + "-" + classEscape(part[1])
            : classEscape(part);
        });

        return "[" + (expectation.inverted ? "^" : "") + escapedParts + "]";
      },

      any: function() {
        return "any character";
      },

      end: function() {
        return "end of input";
      },

      other: function(expectation) {
        return expectation.description;
      },

      not: function(expectation) {
        return "not " + describeExpectation(expectation.expected);
      }
    };

    function hex(ch) {
      return ch.charCodeAt(0).toString(16).toUpperCase();
    }

    function literalEscape(s) {
      return s
        .replace(/\\/g, "\\\\")
        .replace(/"/g,  "\\\"")
        .replace(/\0/g, "\\0")
        .replace(/\t/g, "\\t")
        .replace(/\n/g, "\\n")
        .replace(/\r/g, "\\r")
        .replace(/[\x00-\x0F]/g,          function(ch) { return "\\x0" + hex(ch); })
        .replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) { return "\\x"  + hex(ch); });
    }

    function classEscape(s) {
      return s
        .replace(/\\/g, "\\\\")
        .replace(/\]/g, "\\]")
        .replace(/\^/g, "\\^")
        .replace(/-/g,  "\\-")
        .replace(/\0/g, "\\0")
        .replace(/\t/g, "\\t")
        .replace(/\n/g, "\\n")
        .replace(/\r/g, "\\r")
        .replace(/[\x00-\x0F]/g,          function(ch) { return "\\x0" + hex(ch); })
        .replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) { return "\\x"  + hex(ch); });
    }

    function describeExpectation(expectation) {
      return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
    }

    function describeExpected(expected) {
      var descriptions = expected.map(describeExpectation);
      var i, j;

      descriptions.sort();

      if (descriptions.length > 0) {
        for (i = 1, j = 1; i < descriptions.length; i++) {
          if (descriptions[i - 1] !== descriptions[i]) {
            descriptions[j] = descriptions[i];
            j++;
          }
        }
        descriptions.length = j;
      }

      switch (descriptions.length) {
        case 1:
          return descriptions[0];

        case 2:
          return descriptions[0] + " or " + descriptions[1];

        default:
          return descriptions.slice(0, -1).join(", ")
            + ", or "
            + descriptions[descriptions.length - 1];
      }
    }

    function describeFound(found) {
      return found ? "\"" + literalEscape(found) + "\"" : "end of input";
    }

    return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
  }
}

function peg$parse(input: string, options?: ParserOptions): PartLibrary {
  options = options !== undefined ? options : {};

  var peg$FAILED = {};

  var peg$startRuleFunctions = { PartLibrary: peg$parsePartLibrary };
  var peg$startRuleFunction = peg$parsePartLibrary;

  var peg$c0 = "EESchema-LIBRARY Version ";
  var peg$c1 = ".";
  var peg$c2 = "DEF";
  var peg$c3 = "0";
  var peg$c4 = "ENDDEF";
  var peg$c5 = "F";
  var peg$c6 = "$FPLIST";
  var peg$c7 = "$ENDFPLIST";
  var peg$c8 = "ALIAS";
  var peg$c9 = "DRAW";
  var peg$c10 = "ENDDRAW";
  var peg$c11 = "A";
  var peg$c12 = "C";
  var peg$c13 = "P";
  var peg$c14 = "S";
  var peg$c15 = "T";
  var peg$c16 = "X";
  var peg$c17 = "-";
  var peg$c18 = "Italic";
  var peg$c19 = "Normal";
  var peg$c20 = "N";
  var peg$c21 = "IC";
  var peg$c22 = "CI";
  var peg$c23 = "LC";
  var peg$c24 = "CL";
  var peg$c25 = "L";
  var peg$c26 = "I";
  var peg$c27 = "V";
  var peg$c28 = "\"";

  var peg$r0 = /^[0-9]/;
  var peg$r1 = /^[^\n]/;
  var peg$r2 = /^[^ \t\n\r$]/;
  var peg$r3 = /^[^ \t\n\r]/;
  var peg$r4 = /^[YN]/;
  var peg$r5 = /^[FL0]/;
  var peg$r6 = /^[PN]/;
  var peg$r7 = /^[HV]/;
  var peg$r8 = /^[VI]/;
  var peg$r9 = /^[01]/;
  var peg$r10 = /^[CLR]/;
  var peg$r11 = /^[CTB]/;
  var peg$r12 = /^[IN]/;
  var peg$r13 = /^[BN]/;
  var peg$r14 = /^[fFN]/;
  var peg$r15 = /^[UDLR]/;
  var peg$r16 = /^[IOBTPCENUWw]/;
  var peg$r17 = /^[^"]/;
  var peg$r18 = /^[^ \t\n\v\f\r]/;
  var peg$r19 = /^[^ \t]/;
  var peg$r20 = /^[ \t]/;
  var peg$r21 = /^[\n\r]/;

  var peg$e0 = peg$literalExpectation("EESchema-LIBRARY Version ", false);
  var peg$e1 = peg$classExpectation([["0", "9"]], false, false);
  var peg$e2 = peg$literalExpectation(".", false);
  var peg$e3 = peg$classExpectation(["\n"], true, false);
  var peg$e4 = peg$literalExpectation("DEF", false);
  var peg$e5 = peg$literalExpectation("0", false);
  var peg$e6 = peg$literalExpectation("ENDDEF", false);
  var peg$e7 = peg$literalExpectation("F", false);
  var peg$e8 = peg$literalExpectation("$FPLIST", false);
  var peg$e9 = peg$literalExpectation("$ENDFPLIST", false);
  var peg$e10 = peg$classExpectation([" ", "\t", "\n", "\r", "$"], true, false);
  var peg$e11 = peg$literalExpectation("ALIAS", false);
  var peg$e12 = peg$literalExpectation("DRAW", false);
  var peg$e13 = peg$literalExpectation("ENDDRAW", false);
  var peg$e14 = peg$literalExpectation("A", false);
  var peg$e15 = peg$literalExpectation("C", false);
  var peg$e16 = peg$literalExpectation("P", false);
  var peg$e17 = peg$literalExpectation("S", false);
  var peg$e18 = peg$literalExpectation("T", false);
  var peg$e19 = peg$literalExpectation("X", false);
  var peg$e20 = peg$classExpectation([" ", "\t", "\n", "\r"], true, false);
  var peg$e21 = peg$literalExpectation("-", false);
  var peg$e22 = peg$classExpectation(["Y", "N"], false, false);
  var peg$e23 = peg$classExpectation(["F", "L", "0"], false, false);
  var peg$e24 = peg$classExpectation(["P", "N"], false, false);
  var peg$e25 = peg$classExpectation(["H", "V"], false, false);
  var peg$e26 = peg$classExpectation(["V", "I"], false, false);
  var peg$e27 = peg$classExpectation(["0", "1"], false, false);
  var peg$e28 = peg$classExpectation(["C", "L", "R"], false, false);
  var peg$e29 = peg$classExpectation(["C", "T", "B"], false, false);
  var peg$e30 = peg$literalExpectation("Italic", false);
  var peg$e31 = peg$literalExpectation("Normal", false);
  var peg$e32 = peg$classExpectation(["I", "N"], false, false);
  var peg$e33 = peg$classExpectation(["B", "N"], false, false);
  var peg$e34 = peg$classExpectation(["f", "F", "N"], false, false);
  var peg$e35 = peg$classExpectation(["U", "D", "L", "R"], false, false);
  var peg$e36 = peg$classExpectation(["I", "O", "B", "T", "P", "C", "E", "N", "U", "W", "w"], false, false);
  var peg$e37 = peg$literalExpectation("N", false);
  var peg$e38 = peg$literalExpectation("IC", false);
  var peg$e39 = peg$literalExpectation("CI", false);
  var peg$e40 = peg$literalExpectation("LC", false);
  var peg$e41 = peg$literalExpectation("CL", false);
  var peg$e42 = peg$literalExpectation("L", false);
  var peg$e43 = peg$literalExpectation("I", false);
  var peg$e44 = peg$literalExpectation("V", false);
  var peg$e45 = peg$literalExpectation("\"", false);
  var peg$e46 = peg$classExpectation(["\""], true, false);
  var peg$e47 = peg$classExpectation([" ", "\t", "\n", "\v", "\f", "\r"], true, false);
  var peg$e48 = peg$classExpectation([" ", "\t"], true, false);
  var peg$e49 = peg$otherExpectation("whitespace");
  var peg$e50 = peg$classExpectation(["\n", "\r"], false, false);

  var peg$f0 = function(version: T_LibraryHeader, parts: T_Part[]): PartLibrary {
      // Create a part index
      const index = {};
      parts.forEach((part, partNum) => index[part.partUid] = partNum);

      return { version, parts, index };
    };
  var peg$f1 = function(major: string[], minor: string[]): PartLibraryVersion { 
    	return <PartLibraryVersion>{ 
      	major: parseInt(major.join('')),
      	minor: parseInt(minor.join('')),
      }
    };
  var peg$f2 = function(partdef: T_DEFLine, fields: T_Field[], aliases1: T_Aliases|null, fpFilter: T_FPLIST|null, aliases2: T_Aliases|null, draw: T_DRAWSection): Part {
        // It's rare, but some libraries have the ALIAS section *after* FPLIST
        if (aliases1 && aliases2)
          error("Only one ALIAS section is allowed");

        // Calculate the part UID using SHA256 digest
        const hash = new crypto.Hash('sha256');
        hash.update(text());
        const partUid: string = hash.digest('hex');


        // Helper function: retrieve a field with a given
        // number and remove it from the list
        const retrieveField = (l: Field[], index: number): (Field|undefined) => {
          const listIndex = l.findIndex(f => f.index === index);
          if (listIndex === -1)
            return undefined;
          else 
            return l.splice(listIndex, 1)[0];
        }

        // Find the reference field
        const referenceField = retrieveField(fields, 0);
        const valueField = retrieveField(fields, 1);
        const footprintField = retrieveField(fields, 2);
        const documentField = retrieveField(fields, 3);

        // Ref and value are mandatory
        if (!referenceField)
          error("Missing reference field in component");
        if (!valueField)
          error("Missing value field in component");

        // Determine if part has convert
        const hasConvert = draw.details.reduce((hasConvert, d) => hasConvert || d.convert === Convert.Convert, false);

        const part: Part = { ...partdef, draw, fields, referenceField, valueField, footprintField, documentField, partUid, hasConvert };
        if (aliases1)
          part.aliases = aliases1;
        if (aliases2)
          part.aliases = aliases2;
        if (fpFilter)
          part.fpFilter = fpFilter;


        return part;
    };
  var peg$f3 = function(name: T_Name, ref: T_Name, offset: T_Integer, showPinNumber: T_YN, showPinName: T_YN, numOfParts: T_Positive, locked: T_FL, power: T_PN): PartDef {
      return { name, ref, offset, showPinNumber, showPinName, numOfParts: numOfParts || 1, locked, power }
    };
  var peg$f4 = function(value: T_QuotedString, x: T_Integer, y: T_Integer, size: T_Positive, orientation: T_HV, visible: T_VI, attr: [T_CLR,T_CTB,[T_IN,T_BN]|null]|null): FieldDetails {
      const attributes = attr?
        {
          halign: attr[0],
          valign: attr[1],
          italic: attr[2]? attr[2][0] : false,
          bold: attr[2]? attr[2][1]: false
        }
        :
        // Default field attributes, for older libraries
        {
          halign: HorizontalAlignment.Center,
          valign: VerticalAlignment.Center,
          italic: false,
          bold: false
        }
      return { value, position: {x, y}, size, orientation, visible, ...attributes }
    };
  var peg$f5 = function(index: string[], details: T_FieldDetails, fname: [T__,T_QuotedString]|null): Field {
      const n = parseInt(index.join(''));

      // User field numbering starts at 4
      if (n > 99)
        error("Illegal field index");

      return { index: n, name: fname? fname[1] : undefined, ...details };
    };
  var peg$f6 = function(fp: T_FPPattern[]): string[] { return fp };
  var peg$f7 = function(): string { return text().trim() };
  var peg$f8 = function(names: [T_Name,T__][]): string[] {
      return names.map(v => v[0])
    };
  var peg$f9 = function(details: T_DrawPrimitive[]): DrawSection {
        // Calculate the has of the DRAW section
        const hash = new crypto.Hash('sha256')
        hash.update(text())
        const digest: string = hash.digest('hex')
        
        return {
          details, hash: digest
        } 
      };
  var peg$f10 = function(x: T_Integer, y: T_Integer, radius: T_Positive, startAngle: T_Integer, endAngle: T_Integer, part: T_Positive, convert: T_Convert, pen: T_Integer, extra: [T_FILL,[T_Integer,T_Integer,T_Integer,T_Integer]|null]|null): DrawArc {
            // Code reference: kicad/common/geom.cpp, RotatePoint function
            const rotate = (center: { x: number, y: number }, radius: number, angle: number) => {
              const fangle = angle / 3600.0 * 2 * Math.PI
              const dx = radius * Math.cos(fangle)
              const dy = -radius * Math.sin(fangle)
              return {
                x: Math.round(center.x + dx),
                y: Math.round(center.y + dy)
              }
            }
        
            const arc = { type: DrawPrimitiveType.Arc, 
              center: { x, y },
              radius, startAngle, endAngle, part, convert, pen, fill: FillType.None }

            if (extra) {
              arc.fill = extra[0];
            }
            else
              arc.fill = FillType.None

            // If start and end point are specified, set them. Otherwise,
            // calculate them
            let start;
            let end;
            if (extra && extra[1]) {
                //const v = (<any>(<any>extra)[2]);
                const v = extra[1];
                start = { x: v[0], y: v[1] };
                end = { x: v[2], y: v[3] };
            }
            else {
              // The minus before the angle appears in loadArc method
              // of SCH_LEGACY_PLUGIN_CACHE, in sch_legacy_plugin.cpp
              start = rotate({ x, y }, radius, -startAngle);
              end = rotate({ x, y }, radius, -endAngle);
            }

            return { ...arc, start, end };
      };
  var peg$f11 = function(x: T_Integer, y: T_Integer, radius: T_Positive, part: T_Positive, convert: T_Convert, pen: T_Integer, fill: T_FILL): DrawCircle {
          return { type: DrawPrimitiveType.Circle, center: { x, y }, radius, part, convert, pen, fill }
      };
  var peg$f12 = function(count: T_Positive, part: T_Positive, convert: T_Convert, pen: T_Integer, vertices: [T_Integer,T_Integer][], fill: T_FILL|null): DrawPolyline {
          const vx = vertices.map(v => ({ x: v[0], y: v[1]}));

          // In KiCAD implementation, points beyond count are ignored, but
          // not consideled error.
          // Reference SCH_LEGACY_PLUGIN_CACHE::loadPolyLine method in sch_legacy_plugin.cpp
          return { type: DrawPrimitiveType.Polyline, convert, part, pen, 
            fill: fill || FillType.None, 
            vertices: vx.slice(0, count)
          }
      };
  var peg$f13 = function(x1: T_Integer, y1: T_Integer, x2: T_Integer, y2: T_Integer, part: T_Positive, convert: T_Convert, pen: T_Integer, fill: T_FILL|null): DrawRect {
          return { 
            type: DrawPrimitiveType.Rect,
            topLeft: { x: x1, y: y1 },
            bottomRight: { x: x2, y: y2 },
            part, convert, pen, 
            fill: fill || FillType.None
          }
        };
  var peg$f14 = function(angle: T_Integer, x: T_Integer, y: T_Integer, size: T_Positive, hidden: T_ZeroOne, part: T_Positive, convert: T_Convert, text: T_QuotedOrEscapedString, modifiers: [T_Italic,T_ZeroOne,[T_CLR,T_CTB]|null]|null): DrawText {
        const t: DrawText = {
          type: DrawPrimitiveType.Text,
          position: { x, y }, 
          size, part, convert,
          angle, 
          text: text.replace("''", '"'),  // from loadText function in  
          visible: !hidden,
          italic: false,
          bold: false, 
          halign: HorizontalAlignment.Left,
          valign: VerticalAlignment.Center
        }

        if (modifiers) {
          t.italic = modifiers[0]
          t.bold = modifiers[1]

          // Alignment is optional
          if (modifiers[2]) {
            t.halign = modifiers[2]![0]
            t.valign = modifiers[2]![1]
          }
        }

        return t
      };
  var peg$f15 = function(name: T_PinName, pinNumber: T_PinNumber, x: T_Integer, y: T_Integer, pinLength: T_Positive, orientation: T_Orientation, pinNumberSize: T_Positive, pinNameSize: T_Positive, part: T_Positive, convert: T_Convert, pinType: T_PinType, shape: T_PinShape|null): DrawPin {
          return {
            type: DrawPrimitiveType.Pin,
            position: { x, y },
            name, pinNumber, pinLength, orientation, pinNumberSize, pinNameSize, 
            part, convert, pinType, 
            shape: shape? shape[0] : PinShapeType.Line,
            visible: shape? shape[1] : true
          }
      };
  var peg$f16 = function(): string { return text() };
  var peg$f17 = function(): number { return parseInt(text(), 10); };
  var peg$f18 = function(): boolean { return text()==='Y' };
  var peg$f19 = function(): boolean { return text()==='L' };
  var peg$f20 = function(): boolean { return text()==='P' };
  var peg$f21 = function(): FieldOrientation { return text()==='H'? FieldOrientation.Horizontal : FieldOrientation.Vertical };
  var peg$f22 = function(): boolean { return text()==='V' };
  var peg$f23 = function(): boolean { return text()==='1' };
  var peg$f24 = function(): HorizontalAlignment {
      switch(text()) {
      case 'C': return HorizontalAlignment.Center;
      case 'L': return HorizontalAlignment.Left;
      case 'R': return HorizontalAlignment.Right;
      default: throw error("Internal error");
      }
    };
  var peg$f25 = function(): VerticalAlignment {
      switch(text()) {
      case 'T': return VerticalAlignment.Top;
      case 'C': return VerticalAlignment.Center;
      case 'B': return VerticalAlignment.Bottom
      default: throw error("Internal error");
      }
    };
  var peg$f26 = function(v: (string)): boolean {
        return v==='Italic'
      };
  var peg$f27 = function(): boolean { return text()==='I' };
  var peg$f28 = function(): boolean { return text()==='B' };
  var peg$f29 = function(): FillType {
      const c = text()
      switch(c) {
      case 'f':
        return FillType.Background;
      case 'F':
        return FillType.Foreground;
      default:
        return FillType.None;
      }
    };
  var peg$f30 = function(): DrawOrientationType {
        const c = text()
        switch(c) {
          case 'U': return DrawOrientationType.Up
          case 'D': return DrawOrientationType.Down
          case 'L': return DrawOrientationType.Left
          case 'R': return DrawOrientationType.Right
          default: throw error("Internal error");
        }
      };
  var peg$f31 = function(): PinType {
        const c = text()
        switch(c) {
          case 'I': return PinType.Input;
          case 'O': return PinType.Output;
          case 'B': return PinType.Bidir;
          case 'T': return PinType.Tristate;
          case 'P': return PinType.Passive;
          case 'C': return PinType.OpenCollector;
          case 'E': return PinType.OpenEmitter;
          case 'N': return PinType.NotConnected;
          case 'U': return PinType.Unspecified;
          case 'W': return PinType.PowerInput;
          case 'w': return PinType.PowerOutput;
          default: throw error("Internal error");
        }
      };
  var peg$f32 = function(visible: string|null, shape: (string)|null): [PinShapeType,boolean] {
        const shapes = {
          I: PinShapeType.Inverted,
          C: PinShapeType.Clock,
          L: PinShapeType.InputLow,
          V: PinShapeType.OutputLow,
          F: PinShapeType.FallingEdge,
          X: PinShapeType.NonLogic,
          LC: PinShapeType.ClockLow,
          CL: PinShapeType.ClockLow,
          IC: PinShapeType.ClockInverted,
          CI: PinShapeType.ClockInverted
        }

        return [
          shape? shapes[shape] : PinShapeType.Line,
          (visible !== 'N')
        ]
      };
  var peg$f33 = function(c: string): Convert {
      if (c === '0')
        return Convert.All;
      else if (c === '1')
        return Convert.Regular;
      else if (c === '2')
        return Convert.Convert;
      else
        return Convert.None;
    };
  var peg$f34 = function(inner: string[]): string { return inner.join('') };
  var peg$f35 = function(head: string, tail: string[]): string { return head + tail.join(''); };
  var peg$f36 = function(chars: string[]): string { return chars.join(''); };
  var peg$f37 = function(): string {
        return text().split('~').join(' ');
      };
  var peg$f38 = function(): string { return text(); };
  var peg$f39 = function(): string|null {
        if (text() === "~")
          return null
        else
          return text()
      };

  var peg$currPos = 0;
  var peg$savedPos = 0;
  var peg$posDetailsCache = [{ line: 1, column: 1 }];
  var peg$expected = [];
  var peg$silentFails = 0;

  var peg$result;

  if ("startRule" in options) {
    if (!(options.startRule in peg$startRuleFunctions)) {
      throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
    }

    peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
  }

  function text() {
    return input.substring(peg$savedPos, peg$currPos);
  }

  function offset() {
    return peg$savedPos;
  }

  function range() {
    return [peg$savedPos, peg$currPos];
  }

  function location() {
    return peg$computeLocation(peg$savedPos, peg$currPos);
  }

  function expected(description, location) {
    location = location !== undefined
      ? location
      : peg$computeLocation(peg$savedPos, peg$currPos);

    throw SyntaxError.buildStructuredError(
      [peg$otherExpectation(description)],
      input.substring(peg$savedPos, peg$currPos),
      location
    );
  }

  function error(message: string, location?: Location) {
    throw SyntaxError.buildSimpleError(message, location || peg$computeLocation(peg$savedPos, peg$currPos));
  }

  function peg$literalExpectation(text: string, ignoreCase: boolean): LiteralExpectation {
    return { type: "literal", text: text, ignoreCase: ignoreCase };
  }

  function peg$classExpectation(parts: ClassParts, inverted: boolean, ignoreCase: boolean): ClassExpectation {
    return { type: "class", parts: parts, inverted: inverted, ignoreCase: ignoreCase };
  }

  function peg$anyExpectation(): AnyExpectation {
    return { type: "any" };
  }

  function peg$endExpectation(): EndExpectation {
    return { type: "end" };
  }

  function peg$otherExpectation(description): OtherExpectation {
    return { type: "other", description: description };
  }

  function peg$computePosDetails(pos: number) {
    var details = peg$posDetailsCache[pos];
    var p;

    if (details) {
      return details;
    } else {
      p = pos - 1;
      while (!peg$posDetailsCache[p]) {
        p--;
      }

      details = peg$posDetailsCache[p];
      details = {
        line: details.line,
        column: details.column
      };

      while (p < pos) {
        if (input.charCodeAt(p) === 10) {
          details.line++;
          details.column = 1;
        } else {
          details.column++;
        }

        p++;
      }

      peg$posDetailsCache[pos] = details;

      return details;
    }
  }

  var peg$VALIDFILENAME = typeof options.filename === "string" && options.filename.length > 0;
  function peg$computeLocation(startPos, endPos): Location {

    const filename = peg$VALIDFILENAME? options.filename : undefined;

    var startPosDetails = peg$computePosDetails(startPos);
    const start = {
      offset: startPos,
      line: startPosDetails.line,
      column: startPosDetails.column
    };

    var endPosDetails = peg$computePosDetails(endPos);
    const end = {
      offset: endPos,
      line: endPosDetails.line,
      column: endPosDetails.column
    };

    return { filename, start, end };
  }

  function peg$begin() {
    peg$expected.push({ pos: peg$currPos, variants: [] });
  }

  function peg$expect(expected) {
    var top = peg$expected[peg$expected.length - 1];

    if (peg$currPos < top.pos) { return; }

    if (peg$currPos > top.pos) {
      top.pos = peg$currPos;
      top.variants = [];
    }

    top.variants.push(expected);
  }

  function peg$end(invert) {
    var expected = peg$expected.pop();
    var top = peg$expected[peg$expected.length - 1];
    var variants = expected.variants;

    if (top.pos !== expected.pos) { return; }

    if (invert) {
      variants = variants.map(function(e) {
        return e.type === "not" ? e.expected : { type: "not", expected: e };
      });
    }

    Array.prototype.push.apply(top.variants, variants);
  }

  function peg$buildError() {
    var expected = peg$expected[0];
    var failPos = expected.pos;

    return SyntaxError.buildStructuredError(
      expected.variants,
      failPos < input.length ? input.charAt(failPos) : null,
      failPos < input.length
        ? peg$computeLocation(failPos, failPos + 1)
        : peg$computeLocation(failPos, failPos)
    );
  }

  function peg$parsePartLibrary() {
    var s0, s1, s2, s3;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = peg$parseLibraryHeader();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$parsePart();
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$parsePart();
      }
      peg$savedPos = s0;
      s0 = peg$f0(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseLibraryHeader() {
    var s0, s1, s2, s3, s4, s5, s6;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e0);
    if (input.substr(peg$currPos, 25) === peg$c0) {
      s1 = peg$c0;
      peg$currPos += 25;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = [];
      rule$expects(peg$e1);
      if (peg$r0.test(input.charAt(peg$currPos))) {
        s3 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
      }
      if (s3 !== peg$FAILED) {
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          rule$expects(peg$e1);
          if (peg$r0.test(input.charAt(peg$currPos))) {
            s3 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
          }
        }
      } else {
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        rule$expects(peg$e2);
        if (input.charCodeAt(peg$currPos) === 46) {
          s3 = peg$c1;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
        }
        if (s3 !== peg$FAILED) {
          s4 = [];
          rule$expects(peg$e1);
          if (peg$r0.test(input.charAt(peg$currPos))) {
            s5 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
          }
          if (s5 !== peg$FAILED) {
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              rule$expects(peg$e1);
              if (peg$r0.test(input.charAt(peg$currPos))) {
                s5 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
              }
            }
          } else {
            s4 = peg$FAILED;
          }
          if (s4 !== peg$FAILED) {
            s5 = [];
            rule$expects(peg$e3);
            if (peg$r1.test(input.charAt(peg$currPos))) {
              s6 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
            }
            while (s6 !== peg$FAILED) {
              s5.push(s6);
              rule$expects(peg$e3);
              if (peg$r1.test(input.charAt(peg$currPos))) {
                s6 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s6 = peg$FAILED;
              }
            }
            s6 = peg$parseNEWLINE();
            if (s6 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f1(s2, s4);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsePart() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = peg$parseDEFLine();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$parseField();
      if (s3 !== peg$FAILED) {
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parseField();
        }
      } else {
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        s3 = peg$parseAliases();
        if (s3 === peg$FAILED) {
          s3 = null;
        }
        s4 = peg$parseFPLIST();
        if (s4 === peg$FAILED) {
          s4 = null;
        }
        s5 = peg$parseAliases();
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parseDRAWSection();
        if (s6 !== peg$FAILED) {
          s7 = peg$parseENDDEFLine();
          if (s7 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f2(s1, s2, s3, s4, s5, s6);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseDEFLine() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18, s19, s20;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e4);
    if (input.substr(peg$currPos, 3) === peg$c2) {
      s1 = peg$c2;
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseName();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseName();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          rule$expects(peg$e5);
          if (input.charCodeAt(peg$currPos) === 48) {
            s7 = peg$c3;
            peg$currPos++;
          } else {
            s7 = peg$FAILED;
          }
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseInteger();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parseYN();
              if (s11 !== peg$FAILED) {
                s12 = peg$parse_();
                s13 = peg$parseYN();
                if (s13 !== peg$FAILED) {
                  s14 = peg$parse_();
                  s15 = peg$parsePositive();
                  if (s15 !== peg$FAILED) {
                    s16 = peg$parse_();
                    s17 = peg$parseFL();
                    if (s17 !== peg$FAILED) {
                      s18 = peg$parse_();
                      s19 = peg$parsePN();
                      if (s19 !== peg$FAILED) {
                        s20 = peg$parseNEWLINE();
                        if (s20 !== peg$FAILED) {
                          peg$savedPos = s0;
                          s0 = peg$f3(s3, s5, s9, s11, s13, s15, s17, s19);
                        } else {
                          peg$currPos = s0;
                          s0 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseENDDEFLine() {
    var s0, s1, s2;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e6);
    if (input.substr(peg$currPos, 6) === peg$c4) {
      s1 = peg$c4;
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseNEWLINE();
      if (s2 !== peg$FAILED) {
        s1 = [s1, s2];
        s0 = s1;
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseFieldDetails() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18, s19;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = peg$parseQuotedString();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseInteger();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseInteger();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parsePositive();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseHV();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parseVI();
              if (s11 !== peg$FAILED) {
                s12 = peg$currPos;
                s13 = peg$parse_();
                s14 = peg$parseCLR();
                if (s14 !== peg$FAILED) {
                  s15 = peg$parse_();
                  s16 = peg$parseCTB();
                  if (s16 !== peg$FAILED) {
                    s17 = peg$currPos;
                    s18 = peg$parseIN();
                    if (s18 !== peg$FAILED) {
                      s19 = peg$parseBN();
                      if (s19 !== peg$FAILED) {
                        s18 = [s18, s19];
                        s17 = s18;
                      } else {
                        peg$currPos = s17;
                        s17 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s17;
                      s17 = peg$FAILED;
                    }
                    if (s17 === peg$FAILED) {
                      s17 = null;
                    }
                    s12 = [ s14, s16, s17 ];
                  } else {
                    peg$currPos = s12;
                    s12 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s12;
                  s12 = peg$FAILED;
                }
                if (s12 === peg$FAILED) {
                  s12 = null;
                }
                peg$savedPos = s0;
                s0 = peg$f4(s1, s3, s5, s7, s9, s11, s12);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseField() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e7);
    if (input.charCodeAt(peg$currPos) === 70) {
      s1 = peg$c5;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = [];
      rule$expects(peg$e1);
      if (peg$r0.test(input.charAt(peg$currPos))) {
        s3 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
      }
      if (s3 !== peg$FAILED) {
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          rule$expects(peg$e1);
          if (peg$r0.test(input.charAt(peg$currPos))) {
            s3 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
          }
        }
      } else {
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        s3 = peg$parse_();
        s4 = peg$parseFieldDetails();
        if (s4 !== peg$FAILED) {
          s5 = peg$currPos;
          s6 = peg$parse_();
          s7 = peg$parseQuotedString();
          if (s7 !== peg$FAILED) {
            s6 = [s6, s7];
            s5 = s6;
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
          if (s5 === peg$FAILED) {
            s5 = null;
          }
          s6 = peg$parseNEWLINE();
          if (s6 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f5(s2, s4, s5);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseFPLIST() {
    var s0, s1, s2, s3;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = peg$parseFPLISTStart();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$parseFPPattern();
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$parseFPPattern();
      }
      s3 = peg$parseFPLISTEnd();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f6(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseFPLISTStart() {
    var s0, s1, s2;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e8);
    if (input.substr(peg$currPos, 7) === peg$c6) {
      s1 = peg$c6;
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseNEWLINE();
      if (s2 !== peg$FAILED) {
        s1 = [s1, s2];
        s0 = s1;
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseFPLISTEnd() {
    var s0, s1, s2;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e9);
    if (input.substr(peg$currPos, 10) === peg$c7) {
      s1 = peg$c7;
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseNEWLINE();
      if (s2 !== peg$FAILED) {
        s1 = [s1, s2];
        s0 = s1;
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseFPPattern() {
    var s0, s1, s2, s3;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = peg$parse_();
    s2 = [];
    rule$expects(peg$e10);
    if (peg$r2.test(input.charAt(peg$currPos))) {
      s3 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s3 = peg$FAILED;
    }
    while (s3 !== peg$FAILED) {
      s2.push(s3);
      rule$expects(peg$e10);
      if (peg$r2.test(input.charAt(peg$currPos))) {
        s3 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
      }
    }
    s3 = peg$parseNEWLINE();
    if (s3 !== peg$FAILED) {
      peg$savedPos = s0;
      s0 = peg$f7();
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseAliases() {
    var s0, s1, s2, s3, s4, s5, s6;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e11);
    if (input.substr(peg$currPos, 5) === peg$c8) {
      s1 = peg$c8;
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = [];
      s4 = peg$currPos;
      s5 = peg$parseName();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s5 = [s5, s6];
        s4 = s5;
      } else {
        peg$currPos = s4;
        s4 = peg$FAILED;
      }
      if (s4 !== peg$FAILED) {
        while (s4 !== peg$FAILED) {
          s3.push(s4);
          s4 = peg$currPos;
          s5 = peg$parseName();
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            s5 = [s5, s6];
            s4 = s5;
          } else {
            peg$currPos = s4;
            s4 = peg$FAILED;
          }
        }
      } else {
        s3 = peg$FAILED;
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parseNEWLINE();
        if (s4 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f8(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseDRAWSection() {
    var s0, s1, s2, s3;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = peg$parseDRAWStart();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$parseDrawPrimitive();
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$parseDrawPrimitive();
      }
      s3 = peg$parseDRAWEnd();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f9(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseDRAWStart() {
    var s0, s1, s2;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e12);
    if (input.substr(peg$currPos, 4) === peg$c9) {
      s1 = peg$c9;
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseNEWLINE();
      if (s2 !== peg$FAILED) {
        s1 = [s1, s2];
        s0 = s1;
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseDRAWEnd() {
    var s0, s1, s2;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e13);
    if (input.substr(peg$currPos, 7) === peg$c10) {
      s1 = peg$c10;
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseNEWLINE();
      if (s2 !== peg$FAILED) {
        s1 = [s1, s2];
        s0 = s1;
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseDrawPrimitive() {
    var s0;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$parseDrawArc();
    if (s0 === peg$FAILED) {
      s0 = peg$parseDrawCircle();
      if (s0 === peg$FAILED) {
        s0 = peg$parseDrawPolyline();
        if (s0 === peg$FAILED) {
          s0 = peg$parseDrawRect();
          if (s0 === peg$FAILED) {
            s0 = peg$parseDrawText();
            if (s0 === peg$FAILED) {
              s0 = peg$parseDrawPin();
            }
          }
        }
      }
    }

    return s0;
  }

  function peg$parseDrawArc() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18, s19, s20, s21, s22, s23, s24, s25, s26, s27, s28, s29;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e14);
    if (input.charCodeAt(peg$currPos) === 65) {
      s1 = peg$c11;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseInteger();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseInteger();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parsePositive();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseInteger();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parseInteger();
              if (s11 !== peg$FAILED) {
                s12 = peg$parse_();
                s13 = peg$parsePositive();
                if (s13 !== peg$FAILED) {
                  s14 = peg$parse_();
                  s15 = peg$parseConvert();
                  if (s15 !== peg$FAILED) {
                    s16 = peg$parse_();
                    s17 = peg$parseInteger();
                    if (s17 !== peg$FAILED) {
                      s18 = peg$currPos;
                      s19 = peg$parse_();
                      s20 = peg$parseFILL();
                      s21 = peg$currPos;
                      s22 = peg$parse_();
                      s23 = peg$parseInteger();
                      if (s23 !== peg$FAILED) {
                        s24 = peg$parse_();
                        s25 = peg$parseInteger();
                        if (s25 !== peg$FAILED) {
                          s26 = peg$parse_();
                          s27 = peg$parseInteger();
                          if (s27 !== peg$FAILED) {
                            s28 = peg$parse_();
                            s29 = peg$parseInteger();
                            if (s29 !== peg$FAILED) {
                              s21 = [ s23, s25, s27, s29 ];
                            } else {
                              peg$currPos = s21;
                              s21 = peg$FAILED;
                            }
                          } else {
                            peg$currPos = s21;
                            s21 = peg$FAILED;
                          }
                        } else {
                          peg$currPos = s21;
                          s21 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s21;
                        s21 = peg$FAILED;
                      }
                      if (s21 === peg$FAILED) {
                        s21 = null;
                      }
                      s18 = [ s20, s21 ];
                      s19 = peg$parseNEWLINE();
                      if (s19 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s0 = peg$f10(s3, s5, s7, s9, s11, s13, s15, s17, s18);
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseDrawCircle() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e15);
    if (input.charCodeAt(peg$currPos) === 67) {
      s1 = peg$c12;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseInteger();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseInteger();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parsePositive();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parsePositive();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parseConvert();
              if (s11 !== peg$FAILED) {
                s12 = peg$parse_();
                s13 = peg$parseInteger();
                if (s13 !== peg$FAILED) {
                  s14 = peg$parse_();
                  s15 = peg$parseFILL();
                  s16 = peg$parseNEWLINE();
                  if (s16 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s0 = peg$f11(s3, s5, s7, s9, s11, s13, s15);
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseDrawPolyline() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e16);
    if (input.charCodeAt(peg$currPos) === 80) {
      s1 = peg$c13;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parsePositive();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parsePositive();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseConvert();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseInteger();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = [];
              s12 = peg$currPos;
              s13 = peg$parseInteger();
              if (s13 !== peg$FAILED) {
                s14 = peg$parse_();
                s15 = peg$parseInteger();
                if (s15 !== peg$FAILED) {
                  s16 = peg$parse_();
                  s12 = [ s13, s15 ];
                } else {
                  peg$currPos = s12;
                  s12 = peg$FAILED;
                }
              } else {
                peg$currPos = s12;
                s12 = peg$FAILED;
              }
              if (s12 !== peg$FAILED) {
                while (s12 !== peg$FAILED) {
                  s11.push(s12);
                  s12 = peg$currPos;
                  s13 = peg$parseInteger();
                  if (s13 !== peg$FAILED) {
                    s14 = peg$parse_();
                    s15 = peg$parseInteger();
                    if (s15 !== peg$FAILED) {
                      s16 = peg$parse_();
                      s12 = [ s13, s15 ];
                    } else {
                      peg$currPos = s12;
                      s12 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s12;
                    s12 = peg$FAILED;
                  }
                }
              } else {
                s11 = peg$FAILED;
              }
              if (s11 !== peg$FAILED) {
                s12 = peg$parseFILL();
                s13 = peg$parseNEWLINE();
                if (s13 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f12(s3, s5, s7, s9, s11, s12);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseDrawRect() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e17);
    if (input.charCodeAt(peg$currPos) === 83) {
      s1 = peg$c14;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseInteger();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseInteger();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseInteger();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseInteger();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parsePositive();
              if (s11 !== peg$FAILED) {
                s12 = peg$parse_();
                s13 = peg$parseConvert();
                if (s13 !== peg$FAILED) {
                  s14 = peg$parse_();
                  s15 = peg$parseInteger();
                  if (s15 !== peg$FAILED) {
                    s16 = peg$parse_();
                    s17 = peg$parseFILL();
                    s18 = peg$parseNEWLINE();
                    if (s18 !== peg$FAILED) {
                      peg$savedPos = s0;
                      s0 = peg$f13(s3, s5, s7, s9, s11, s13, s15, s17);
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseDrawText() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18, s19, s20, s21, s22, s23, s24, s25, s26, s27;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e18);
    if (input.charCodeAt(peg$currPos) === 84) {
      s1 = peg$c15;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseInteger();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseInteger();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseInteger();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parsePositive();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parseZeroOne();
              if (s11 !== peg$FAILED) {
                s12 = peg$parse_();
                s13 = peg$parsePositive();
                if (s13 !== peg$FAILED) {
                  s14 = peg$parse_();
                  s15 = peg$parseConvert();
                  if (s15 !== peg$FAILED) {
                    s16 = peg$parse_();
                    s17 = peg$parseQuotedOrEscapedString();
                    if (s17 !== peg$FAILED) {
                      s18 = peg$currPos;
                      s19 = peg$parse_();
                      s20 = peg$parseItalic();
                      if (s20 !== peg$FAILED) {
                        s21 = peg$parse_();
                        s22 = peg$parseZeroOne();
                        if (s22 !== peg$FAILED) {
                          s23 = peg$currPos;
                          s24 = peg$parse_();
                          s25 = peg$parseCLR();
                          if (s25 !== peg$FAILED) {
                            s26 = peg$parse_();
                            s27 = peg$parseCTB();
                            if (s27 !== peg$FAILED) {
                              s23 = [ s25, s27 ];
                            } else {
                              peg$currPos = s23;
                              s23 = peg$FAILED;
                            }
                          } else {
                            peg$currPos = s23;
                            s23 = peg$FAILED;
                          }
                          if (s23 === peg$FAILED) {
                            s23 = null;
                          }
                          s18 = [ s20, s22, s23 ];
                        } else {
                          peg$currPos = s18;
                          s18 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s18;
                        s18 = peg$FAILED;
                      }
                      if (s18 === peg$FAILED) {
                        s18 = null;
                      }
                      s19 = peg$parseNEWLINE();
                      if (s19 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s0 = peg$f14(s3, s5, s7, s9, s11, s13, s15, s17, s18);
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseDrawPin() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18, s19, s20, s21, s22, s23, s24, s25, s26;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e19);
    if (input.charCodeAt(peg$currPos) === 88) {
      s1 = peg$c16;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parsePinName();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parsePinNumber();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseInteger();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseInteger();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parsePositive();
              if (s11 !== peg$FAILED) {
                s12 = peg$parse_();
                s13 = peg$parseOrientation();
                if (s13 !== peg$FAILED) {
                  s14 = peg$parse_();
                  s15 = peg$parsePositive();
                  if (s15 !== peg$FAILED) {
                    s16 = peg$parse_();
                    s17 = peg$parsePositive();
                    if (s17 !== peg$FAILED) {
                      s18 = peg$parse_();
                      s19 = peg$parsePositive();
                      if (s19 !== peg$FAILED) {
                        s20 = peg$parse_();
                        s21 = peg$parseConvert();
                        if (s21 !== peg$FAILED) {
                          s22 = peg$parse_();
                          s23 = peg$parsePinType();
                          if (s23 !== peg$FAILED) {
                            s24 = peg$parse_();
                            s25 = peg$parsePinShape();
                            s26 = peg$parseNEWLINE();
                            if (s26 !== peg$FAILED) {
                              peg$savedPos = s0;
                              s0 = peg$f15(s3, s5, s7, s9, s11, s13, s15, s17, s19, s21, s23, s25);
                            } else {
                              peg$currPos = s0;
                              s0 = peg$FAILED;
                            }
                          } else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                          }
                        } else {
                          peg$currPos = s0;
                          s0 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseName() {
    var s0, s1, s2;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = [];
    rule$expects(peg$e20);
    if (peg$r3.test(input.charAt(peg$currPos))) {
      s2 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        rule$expects(peg$e20);
        if (peg$r3.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f16();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseInteger() {
    var s0, s1, s2, s3;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e21);
    if (input.charCodeAt(peg$currPos) === 45) {
      s1 = peg$c17;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = [];
    rule$expects(peg$e1);
    if (peg$r0.test(input.charAt(peg$currPos))) {
      s3 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s3 = peg$FAILED;
    }
    if (s3 !== peg$FAILED) {
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        rule$expects(peg$e1);
        if (peg$r0.test(input.charAt(peg$currPos))) {
          s3 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
        }
      }
    } else {
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      peg$savedPos = s0;
      s0 = peg$f17();
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsePositive() {
    var s0, s1, s2;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = [];
    rule$expects(peg$e1);
    if (peg$r0.test(input.charAt(peg$currPos))) {
      s2 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        rule$expects(peg$e1);
        if (peg$r0.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f17();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseYN() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e22);
    if (peg$r4.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f18();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseFL() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e23);
    if (peg$r5.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f19();
    }
    s0 = s1;

    return s0;
  }

  function peg$parsePN() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e24);
    if (peg$r6.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f20();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseHV() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e25);
    if (peg$r7.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f21();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseVI() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e26);
    if (peg$r8.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f22();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseZeroOne() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e27);
    if (peg$r9.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f23();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseCLR() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e28);
    if (peg$r10.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f24();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseCTB() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e29);
    if (peg$r11.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f25();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseItalic() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e30);
    if (input.substr(peg$currPos, 6) === peg$c18) {
      s1 = peg$c18;
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      rule$expects(peg$e31);
      if (input.substr(peg$currPos, 6) === peg$c19) {
        s1 = peg$c19;
        peg$currPos += 6;
      } else {
        s1 = peg$FAILED;
      }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f26(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseIN() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e32);
    if (peg$r12.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f27();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseBN() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e33);
    if (peg$r13.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f28();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseFILL() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e34);
    if (peg$r14.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    peg$savedPos = s0;
    s1 = peg$f29();
    s0 = s1;

    return s0;
  }

  function peg$parseOrientation() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e35);
    if (peg$r15.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f30();
    }
    s0 = s1;

    return s0;
  }

  function peg$parsePinType() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e36);
    if (peg$r16.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f31();
    }
    s0 = s1;

    return s0;
  }

  function peg$parsePinShape() {
    var s0, s1, s2;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e37);
    if (input.charCodeAt(peg$currPos) === 78) {
      s1 = peg$c20;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    rule$expects(peg$e38);
    if (input.substr(peg$currPos, 2) === peg$c21) {
      s2 = peg$c21;
      peg$currPos += 2;
    } else {
      s2 = peg$FAILED;
    }
    if (s2 === peg$FAILED) {
      rule$expects(peg$e39);
      if (input.substr(peg$currPos, 2) === peg$c22) {
        s2 = peg$c22;
        peg$currPos += 2;
      } else {
        s2 = peg$FAILED;
      }
      if (s2 === peg$FAILED) {
        rule$expects(peg$e40);
        if (input.substr(peg$currPos, 2) === peg$c23) {
          s2 = peg$c23;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
        }
        if (s2 === peg$FAILED) {
          rule$expects(peg$e41);
          if (input.substr(peg$currPos, 2) === peg$c24) {
            s2 = peg$c24;
            peg$currPos += 2;
          } else {
            s2 = peg$FAILED;
          }
          if (s2 === peg$FAILED) {
            rule$expects(peg$e42);
            if (input.charCodeAt(peg$currPos) === 76) {
              s2 = peg$c25;
              peg$currPos++;
            } else {
              s2 = peg$FAILED;
            }
            if (s2 === peg$FAILED) {
              rule$expects(peg$e15);
              if (input.charCodeAt(peg$currPos) === 67) {
                s2 = peg$c12;
                peg$currPos++;
              } else {
                s2 = peg$FAILED;
              }
              if (s2 === peg$FAILED) {
                rule$expects(peg$e43);
                if (input.charCodeAt(peg$currPos) === 73) {
                  s2 = peg$c26;
                  peg$currPos++;
                } else {
                  s2 = peg$FAILED;
                }
                if (s2 === peg$FAILED) {
                  rule$expects(peg$e44);
                  if (input.charCodeAt(peg$currPos) === 86) {
                    s2 = peg$c27;
                    peg$currPos++;
                  } else {
                    s2 = peg$FAILED;
                  }
                  if (s2 === peg$FAILED) {
                    rule$expects(peg$e7);
                    if (input.charCodeAt(peg$currPos) === 70) {
                      s2 = peg$c5;
                      peg$currPos++;
                    } else {
                      s2 = peg$FAILED;
                    }
                    if (s2 === peg$FAILED) {
                      rule$expects(peg$e19);
                      if (input.charCodeAt(peg$currPos) === 88) {
                        s2 = peg$c16;
                        peg$currPos++;
                      } else {
                        s2 = peg$FAILED;
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
    if (s2 === peg$FAILED) {
      s2 = null;
    }
    peg$savedPos = s0;
    s0 = peg$f32(s1, s2);

    return s0;
  }

  function peg$parseConvert() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e1);
    if (peg$r0.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f33(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseQuotedString() {
    var s0, s1, s2, s3;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e45);
    if (input.charCodeAt(peg$currPos) === 34) {
      s1 = peg$c28;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = [];
      rule$expects(peg$e46);
      if (peg$r17.test(input.charAt(peg$currPos))) {
        s3 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        rule$expects(peg$e46);
        if (peg$r17.test(input.charAt(peg$currPos))) {
          s3 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
        }
      }
      rule$expects(peg$e45);
      if (input.charCodeAt(peg$currPos) === 34) {
        s3 = peg$c28;
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f34(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseUnquotedString() {
    var s0, s1, s2, s3;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    rule$expects(peg$e46);
    if (peg$r17.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = [];
      rule$expects(peg$e47);
      if (peg$r18.test(input.charAt(peg$currPos))) {
        s3 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        rule$expects(peg$e47);
        if (peg$r18.test(input.charAt(peg$currPos))) {
          s3 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
        }
      }
      peg$savedPos = s0;
      s0 = peg$f35(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseAlphaNumericString() {
    var s0, s1, s2;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = [];
    rule$expects(peg$e48);
    if (peg$r19.test(input.charAt(peg$currPos))) {
      s2 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        rule$expects(peg$e48);
        if (peg$r19.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f36(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseEscapedString() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = peg$parseUnquotedString();
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f37();
    }
    s0 = s1;

    return s0;
  }

  function peg$parseQuotedOrEscapedString() {
    var s0;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$parseQuotedString();
    if (s0 === peg$FAILED) {
      s0 = peg$parseEscapedString();
    }

    return s0;
  }

  function peg$parsePinName() {
    var s0, s1, s2;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = [];
    rule$expects(peg$e20);
    if (peg$r3.test(input.charAt(peg$currPos))) {
      s2 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        rule$expects(peg$e20);
        if (peg$r3.test(input.charAt(peg$currPos))) {
          s2 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f38();
    }
    s0 = s1;

    return s0;
  }

  function peg$parsePinNumber() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = peg$currPos;
    s1 = peg$parseAlphaNumericString();
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f39();
    }
    s0 = s1;

    return s0;
  }

  function peg$parse_() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    rule$expects(peg$e49);
    peg$silentFails++;
    s0 = [];
    if (peg$r20.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    while (s1 !== peg$FAILED) {
      s0.push(s1);
      if (peg$r20.test(input.charAt(peg$currPos))) {
        s1 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
      }
    }
    peg$silentFails--;

    return s0;
  }

  function peg$parseNEWLINE() {
    var s0, s1;

    var rule$expects = function (expected) {
      if (peg$silentFails === 0) peg$expect(expected);
    }

    s0 = [];
    rule$expects(peg$e50);
    if (peg$r21.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      while (s1 !== peg$FAILED) {
        s0.push(s1);
        rule$expects(peg$e50);
        if (peg$r21.test(input.charAt(peg$currPos))) {
          s1 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
        }
      }
    } else {
      s0 = peg$FAILED;
    }

    return s0;
  }

  peg$begin();
  peg$result = peg$startRuleFunction();

  if (peg$result !== peg$FAILED && peg$currPos === input.length) {
    return peg$result;
  } else {
    if (peg$result !== peg$FAILED && peg$currPos < input.length) {
      peg$expect(peg$endExpectation());
    }

    throw peg$buildError();
  }
}

export const parse = peg$parse;
export const parsePartLibrary = (input: string, options?: ParserOptions): PartLibrary => <PartLibrary>peg$parse(input, { ...( options || {} ), startRule: "PartLibrary" });